///////////////////////////////////////////////
//  t\Cu@for p33fxxxx
//  ȉ̋@\
//    LCD_int()     ----- 
//    LCD_dat(chr)  ----- P\
//    LCD_str(*char) ---- \
//    LCD_posyx(y,x) ---- J[\ʒuwAs yAʒu x
//    LCD_clr()     ----- S
//    LCD_hex(chr)  ----- PUiϊ\
// Copyright (c) 2012 iwamoto All Rights Reserved
//////////////////////////////////////////////

#include "p33fxxxx.h"
#include "L_sLCD.h"

//-------- P\
void LCD_dat(char c){
	while (U2STAbits.UTXBF);	//BusyUART
	U2TXREG = c;
	if(c == 0x01){  // Clear
		Delay_2mS;   // 2msec@ClearHomeR}h
	}else{
		Delay_50uS;  // 50usec
    }   
}
//-------- S
void LCD_clr(void){
	LCD_dat(0x01);		//ClearR}ho
}
//-------- J[\ʒuw
void LCD_posyx(char ypos, char xpos){
    if((ypos >= 0) && (ypos < 4)){
		LCD_dat(ypos + 2);
    }
    if((xpos >= 0) && (xpos < 20)){
		LCD_dat(xpos | 0x80);
	}
}
//-------- o
void LCD_str(char *str){
    while(*str)            //̏I(00)܂Ōp
        LCD_dat(*str++);   //o͂|C^{P
}
//-------- o w
void LCD_strNum(char *str, char num){
   while(num--)           //w蕶܂Ōp
       LCD_dat(*str++);   //o͂|C^{P
}
//-------- PUiϊ\
void LCD_hex(char c){
    LCD_hxH(c);
    LCD_hxL(c);
}
//****************************************************************
//  LCD_hxL(char) ̉ʂSrbĝPUi\
//  LCD_hxH(char) ̏ʂSrbĝPUi\
//****************************************************************
void LCD_hxL(char c){
    c = c & 0x0F;            // ʂSrbgo
    if(c < 10){              // 9ȉȂ
        c += 0x30;           //   '0'̕R[h
    }else{                   // 10ȏȂ
        c += (0x41-10);      //   (c-10)
    }                        //   'A'̕R[h
    LCD_dat(c);              // ʂ̂PUi\
}
void LCD_hxH(char c){        // ʂSrbgʂɈړ
    LCD_hxL(c >> 4);          // ʂ̂PUi\
}
//-------- 
void LCD_int(void){
//    _TRISF3 = 0;            // UART TX Port  ??
//    _TRISF2 = 1;            // UART RX Port  ??
    // UART2 ݒ ------------------------------- 
    // 8-bit no parity 1 stop bit 
    // 
    // ------------------------------------------
    UART2_RX_TRIS = 1;
    UART2_TX_TRIS = 0;
//    U2BRG = 128;            // ((FCY/19.2kbps)/16) - 1
    U2BRG = 259;            // ((FCY/9600bps)/16) - 1
    //        <--><--><--><-->
    U2MODE= 0b1000100000000000; 
    U2STA = 0b0000010000000000; 

	Delay_100mS;     // sLCDjbg莞(min40mSec)
	LCD_dat(0x01);		//ClearR}ho
}
