//*************************************************************
// LCD Cu@PIC33F
//
//    LCD_int()     ----------- (100msecPwrOn艻x܂ށj
//    LCD_dat(chr)  ----------- P\
//    LCD_str(*str) ----------- \
//    LCD_strNum(*str, num) --- w蕶\
//    LCD_posyx(y,x) ---------- J[\ʒuwAs yAʒu x
//    LCD_clr()     ----------- S
//
//t\PIC̓VA19.2k BoudŐڑ
//     1)Define I/O PORT
//             U2TX  pin32 RF5
//            (U2RX  pin31 RF4)
//     2)OSC
//         NbN@39.6MHz Fcy
//
// Copyright (c) 2012 iwamoto All Rights Reserved
//************* I/O Define **********************
// 
#define FCY 39613750UL    // 
// #define BAUDRATE 19200
// #define BRGVAL ((FCY/BAUDRATE)/16)-1
/* The UART and their ports    */
#define UART2_RX_TRIS     _TRISF4
#define UART2_TX_TRIS     _TRISF5
#define UART2_RX          _RF4
#define UART2_TX          _LATF5

#include <libpic30.h>     // Delay֐
//
//************* Delay *******************************************
// KvƂfBCԂNbNgw肷

//*************** Delay Define 4MHz ********************
#define  Delay_50uS  __delay_us(50)
#define  Delay_2mS   __delay_ms(2)
#define  Delay_100mS __delay_ms(100)
//********************************************************
void LCD_dat(char);
void LCD_clr(void);
void LCD_int(void);
void LCD_str(char *);
void LCD_strNum(char *, char);
void LCD_posyx(char,char);
void LCD_hex(char);

void LCD_hxH(char);
void LCD_hxL(char);
